﻿@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Portal.Models.Delivery.Invoice;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.Common().DevExpress().GridView(
setting =>
{

    setting.Name = "DJPostHeaderGrid";
    setting.Width = Unit.Percentage(100);
    setting.Settings.ShowFilterRow = true;
    setting.Settings.ShowFilterRowMenu = true;
    setting.Settings.ShowColumnHeaders = true;
    setting.KeyFieldName = "DOC_NO";

    setting.CallbackRouteValues = new { Controller = "D31408", Action = "JournalPostTab" };
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGridPostHeader";
    //setting.ClientSideEvents.EndCallback = "OnEndCallbackGridPostHeader";
    //setting.ClientSideEvents.Init = "GridDeliveryInvoiceAndPay_Init";
    setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
    setting.SettingsBehavior.AllowSelectByRowClick = true;

    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    setting.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Styles.Header.VerticalAlign = VerticalAlign.Middle;

    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;
    setting.SettingsPager.ShowNumericButtons = true;
    //setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
    setting.SettingsPager.Position = PagerPosition.Bottom;
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";

    setting.CommandColumn.Visible = true;
    setting.CommandColumn.Width = Unit.Pixel(40);
    setting.CommandColumn.ClearFilterButton.Visible = true;
    setting.CommandColumn.ShowSelectCheckbox = true;

    //setting.ClientSideEvents.SelectionChanged = "";

    if (setting.SettingsBehavior.AllowSelectSingleRowOnly == false)
    {
        setting.CommandColumn.SetHeaderTemplateContent(
        c =>
        {
            Html.DevExpress().CheckBox(settingsCheckBox =>
            {
                settingsCheckBox.Name = "DJPostCheckBox";
                settingsCheckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
                settingsCheckBox.Checked = (c.Grid.Selection.Count == c.Grid.VisibleRowCount) && (c.Grid.Selection.Count > 0);
            }).Render();

        });
    }

    setting.CustomJSProperties = (s, e) =>
    {
        MVCxGridView grid = (MVCxGridView)s;
        int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
        int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
        object[] Document_No = new object[end - startIndex];
        object[] Document_Year = new object[end - startIndex];
        object[] Document_Date = new object[end - startIndex];

        for (int n = startIndex; n < end; n++)
        {
            Document_No[n - startIndex] = grid.GetRowValues(n, "DOC_NO");
            Document_Year[n - startIndex] = grid.GetRowValues(n, "DOC_YEAR");
            Document_Date[n - startIndex] = grid.GetRowValues(n, "DOC_DT");
        }
        e.Properties["cpDocument_No"] = Document_No;
        e.Properties["cpDocument_Year"] = Document_Year;
        e.Properties["cpDocument_Date"] = Document_Date;
        grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
    };

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_NO";
        col.Caption = "Document No";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

        col.SetDataItemTemplateContent(
        content =>
        {
            GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
            Html.DevExpress().HyperLink(
                link =>
                {
                    link.Name = "lnkDOC_NO" + content.VisibleIndex;
                    link.NavigateUrl = "javascript:void(0)";
                    link.Properties.Text = content.Text;
                    link.ClientVisible = true;
                    link.Width = 100;
                    link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnDocumentClick('{0}'); }}", DataBinder.Eval(content.DataItem, "DOC_NO") == null ? "" : DataBinder.Eval(content.DataItem, "DOC_NO").ToString());
                }).Render();
        });

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_YEAR";
        col.Caption = "Document Year";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_DT";
        col.Caption = "Document Date";
        col.Width = Unit.Pixel(100);
        col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "POSTING_DT";
        col.Caption = "Posting Date";
        col.Width = Unit.Pixel(100);
        col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_HEADER_TXT";
        col.Caption = "Header Text";
        col.Width = Unit.Pixel(130);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "REFF_NO";
        col.Caption = "Reff. No";
        col.Width = Unit.Pixel(200);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "LP_CD";
        col.Caption = "Supplier CD.";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CUSTOMER_CD";
        col.Caption = "Customer CD.";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "PAYMENT_TERM_CD";
        col.Caption = "Payment Term CD.";
        col.Width = Unit.Pixel(120);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "PAYMENT_METHOD_CD";
        col.Caption = "Payment Method CD.";
        col.Width = Unit.Pixel(130);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "PARTNER_BANK_KEY";
        col.Caption = "Partner Bank Key";
        col.Width = Unit.Pixel(120);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "ACCT_DOC_NO";
        col.Caption = "Accounting Doc. No.";
        col.Width = Unit.Pixel(130);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "ACCT_DOC_YEAR";
        col.Caption = "Accounting Doc. Year";
        col.Width = Unit.Pixel(140);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "HEADER_TYPE";
        col.Caption = "Header Type";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "POSTING_STS";
        col.Caption = "Posting Status";
        col.Width = Unit.Pixel(100);
        col.Settings.FilterMode = ColumnFilterMode.Value;
        col.ColumnType = MVCxGridViewColumnType.ComboBox;
        var comboSetting = col.PropertiesEdit as ComboBoxProperties;
        comboSetting.Items.Add("", "");
        comboSetting.Items.Add("NOT YET", "NOT YET");
        comboSetting.Items.Add("IN PROGRESS", "IN PROGRESS");
        comboSetting.Items.Add("ERROR", "ERROR");
        comboSetting.Items.Add("SUCCESS", "SUCCESS");
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });
    
    setting.Columns.Add(col =>
    {
        col.FieldName = "ERROR_POSTING";
        col.Caption = "Error Posting";
        col.Width = Unit.Pixel(500);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CREATED_BY";
        col.Caption = "Created By";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CREATED_DT";
        col.Caption = "Created Date";
        col.Width = Unit.Pixel(100);
        col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CHANGED_BY";
        col.Caption = "Changed By";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CHANGED_DT";
        col.Caption = "Changed Date";
        col.Width = Unit.Pixel(100);
        col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.CustomColumnDisplayText = (sender, e) =>
    {
        if ((e.Column.FieldName == "CREATED_DT") || (e.Column.FieldName == "CHANGED_DT")
            || (e.Column.FieldName == "DOC_DT") || (e.Column.FieldName == "POSTING_DT"))
        {
            string formattedDate = String.Format("{0:dd.MM.yyyy}", e.Value);
            if ((formattedDate == "01.01.0001") || (formattedDate == "01.01.1900")) e.DisplayText = "";
            else e.DisplayText = formattedDate;
        }
    };

    setting.HtmlRowPrepared = (s, e) =>
    {
        if (e.GetValue("POSTING_STS") != null)
        {
            if (e.GetValue("POSTING_STS").ToString() == "ERROR POSTING")
                e.Row.BackColor = System.Drawing.Color.Red;

            if (e.GetValue("POSTING_STS").ToString() == "IN PROGRESS")
                e.Row.BackColor = System.Drawing.Color.Yellow;
        }
    };
    
}).Bind(Model.GetModel<Portal.Models.Delivery.Invoice.DeliveryJournalData>().DJPostHeader).GetHtml()

